rm(list=ls())
setwd("e:/ChoiceModels/")
library(fields)

dt <-read.csv("d1000.csv",header=T)

b <- numeric(10)
b[ 1] <-  0.872   #ASC_2tokyo
b[ 2] <-  3.00    #ASC_3hachi
b[ 3] <-  1.67    #ASC_4rail
b[ 4] <-  0.795   #ASC_5seikan
b[ 5] <- -0.00241 #B_TIME
b[ 6] <- -0.00111 #B_COST
b[ 7] <-  0.318   #D_1weight
b[ 8] <- -0.00811 #D_2weight
b[ 9] <- -0.214   #D_3weight
b[10] <-  0.0518  #D_4weight

a32 <- 0.951; a31 <- 1 - a32
a42 <- 0.890; a41 <- 1 - a42
nst <- 0.0518


util <- function(b){
  ns <- nrow(dt)
  v <- array(0,c(ns,5))
  v[,1] <- b[5]*dt[,2] + b[6]*dt[, 7] + b[ 7]*dt[,12]
  v[,2] <- b[5]*dt[,3] + b[6]*dt[, 8] + b[ 8]*dt[,12] + b[1]
  v[,3] <- b[5]*dt[,4] + b[6]*dt[, 9] + b[ 9]*dt[,12] + b[2]
  v[,4] <- b[5]*dt[,5] + b[6]*dt[,10] + b[10]*dt[,12] + b[3]
  v[,5] <- b[5]*dt[,6] + b[6]*dt[,11]                 + b[4]
  return(v)
}

v <- util(b); v <- apply(v,2,mean)
v1 <- v[1]; v2 <- v[2]; v3 <- v[3]; v4 <- v[4]; v5 <- v[5]

par(ask=T,mar=c(5,5,2,3))

res.1 <- array(0,c(100,100))
for(i in 1:100){
  a31 <- i/100
  for(j in 1:100){
    a41 <- j/100
    a42 <- 1-a41
    a32 <- 1-a31
    p1 <- function(a31){
       (
         (exp(v1))^(1/nst) * ( exp(v1/nst)+(a31*exp(v3))^(1/nst) )^(nst-1)
       ) / 
       ( 
         ( exp(v1/nst)+(a31*exp(v3))^(1/nst) )^nst + 
         ( exp(v2/nst)+exp(v5/nst) )^nst +
         ( a41*exp(v4) ) +
         ( (a32*exp(v3))^(1/nst) + (a42*exp(v4))^(1/nst) )^nst
       )
    }
    res.1[i,j] <- p1(a31)
}}
image.plot(res.1,xlab=expression(alpha[31]),ylab=expression(alpha[41]),cex.lab=2)
contour(res.1, add = TRUE)

res.2 <- array(0,c(100,100))
for(i in 1:100){
  a31 <- i/100
  for(j in 1:100){
    a41 <- j/100
    a42 <- 1-a41
    a32 <- 1-a31
    p2 <- function(a31){
       (
         (exp(v2))^(1/nst) * ( exp(v2/nst)+exp(v5/nst) )^(nst-1)
       ) / 
       ( 
         ( exp(v1/nst)+(a31*exp(v3))^(1/nst) )^nst + 
         ( exp(v2/nst)+exp(v5/nst) )^nst +
         ( a41*exp(v4) ) +
         ( (a32*exp(v3))^(1/nst) + (a42*exp(v4))^(1/nst) )^nst
       )
    }
    res.2[i,j] <- p2(a31)
}}
image.plot(res.2,xlab=expression(alpha[31]),ylab=expression(alpha[41]),cex.lab=2)
contour(res.2, add = TRUE)

res.3 <- array(0,c(100,100))
for(i in 1:100){
  a31 <- i/100
  for(j in 1:100){
    a41 <- j/100
    a42 <- 1-a41
    a32 <- 1-a31
    p3 <- function(a31){
       (
         (a31*exp(v3))^(1/nst)*( exp(v1/nst)+(a31*exp(v3))^(1/nst) )^(nst-1) +
         (a32*exp(v3))^(1/nst)*( (a32*exp(v3))^(1/nst) + (a42*exp(v4))^(1/nst) )^(nst-1)
       ) / 
       ( 
         ( exp(v1/nst)+(a31*exp(v3))^(1/nst) )^nst + 
         ( exp(v2/nst)+exp(v5/nst) )^nst +
         ( a41*exp(v4) ) +
         ( (a32*exp(v3))^(1/nst) + (a42*exp(v4))^(1/nst) )^nst
       )
    }
    res.3[i,j] <- p3(a31)
}}
image.plot(res.3,xlab=expression(alpha[31]),ylab=expression(alpha[41]),cex.lab=2)
contour(res.3, add = TRUE)

res.4 <- array(0,c(100,100))
for(i in 1:100){
  a31 <- i/100
  for(j in 1:100){
    a41 <- j/100
    a42 <- 1-a41
    a32 <- 1-a31
    p4 <- function(a31){
       (
         (a41*exp(v4))^(1/nst)*( (a41*exp(v4))^(1/nst) )^(nst-1) +
         (a42*exp(v4))^(1/nst)*( (a32*exp(v3))^(1/nst) + (a42*exp(v4))^(1/nst) )^(nst-1)
       ) / 
       ( 
         ( exp(v1/nst)+(a31*exp(v3))^(1/nst) )^nst + 
         ( exp(v2/nst)+exp(v5/nst) )^nst +
         ( a41*exp(v4) ) +
         ( (a32*exp(v3))^(1/nst) + (a42*exp(v4))^(1/nst) )^nst
       )
    }
    res.4[i,j] <- p4(a31)
}}
image.plot(res.4,xlab=expression(alpha[31]),ylab=expression(alpha[41]),cex.lab=2)
contour(res.4, add = TRUE)

res.5 <- array(0,c(100,100))
for(i in 1:100){
  a31 <- i/100
  for(j in 1:100){
    a41 <- j/100
    a42 <- 1-a41
    a32 <- 1-a31
    p5 <- function(a31){
       (
         (exp(v5))^(1/nst) * ( exp(v2/nst)+exp(v5/nst) )^(nst-1)
       ) / 
       ( 
         ( exp(v1/nst)+(a31*exp(v3))^(1/nst) )^nst + 
         ( exp(v2/nst)+exp(v5/nst) )^nst +
         ( a41*exp(v4) ) +
         ( (a32*exp(v3))^(1/nst) + (a42*exp(v4))^(1/nst) )^nst
       )
    }
    res.5[i,j] <- p5(a31)
}}
image.plot(res.5,xlab=expression(alpha[31]),ylab=expression(alpha[41]),cex.lab=2)
contour(res.5, add = TRUE)


