rm(list=ls())
setwd("e:/ChoiceModels/")
library(mlogit)

dt <-read.csv("d1000.csv",header=T)

md <- matrix("",nrow=nrow(dt),ncol=1); mm <- c("1iba","2tokyo","3hachi","4rail","5seikan")
md <- mm[dt[,1]]; dt[,1] <- md
colnames(dt)[ 2] <- "time.1iba"
colnames(dt)[ 3] <- "time.2tokyo"
colnames(dt)[ 4] <- "time.3hachi"
colnames(dt)[ 5] <- "time.4rail"
colnames(dt)[ 6] <- "time.5seikan"

colnames(dt)[ 7] <- "cost.1iba"
colnames(dt)[ 8] <- "cost.2tokyo"
colnames(dt)[ 9] <- "cost.3hachi"
colnames(dt)[10] <- "cost.4rail"
colnames(dt)[11] <- "cost.5seikan"

colnames(dt)[12] <- "wei1.1iba"
colnames(dt)[13] <- "wei1.2tokyo"
colnames(dt)[14] <- "wei1.3hachi"
colnames(dt)[15] <- "wei1.4rail"
colnames(dt)[16] <- "wei1.5seikan"

colnames(dt)[17] <- "wei2.1iba"
colnames(dt)[18] <- "wei2.2tokyo"
colnames(dt)[19] <- "wei2.3hachi"
colnames(dt)[20] <- "wei2.4rail"
colnames(dt)[21] <- "wei2.5seikan"

colnames(dt)[22] <- "wei3.1iba"
colnames(dt)[23] <- "wei3.2tokyo"
colnames(dt)[24] <- "wei3.3hachi"
colnames(dt)[25] <- "wei3.4rail"
colnames(dt)[26] <- "wei3.5seikan"

colnames(dt)[27] <- "wei4.1iba"
colnames(dt)[28] <- "wei4.2tokyo"
colnames(dt)[29] <- "wei4.3hachi"
colnames(dt)[30] <- "wei4.4rail"
colnames(dt)[31] <- "wei4.5seikan"

m_dt <- mlogit.data(dt,varying=c(2:31),shape="wide",choice="mode")

mnl <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt)
summary(mnl)

b0 <- c(summary(mnl)$CoefTable[,1], 1)


para <- array(0,c(11,50))
tval <- array(0,c(11,50))
llk  <- numeric(50)
nl.st <- character(50)

#######################################
#01
nl_1_2345 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n1 = c('1iba'),
                       n2345  = c('2tokyo','3hachi','4rail','5seikan')), un.nest.el=T)
summary(nl_1_2345)
para[, 1] <- summary(nl_1_2345)$CoefTable[,1]
tval[, 1] <- summary(nl_1_2345)$CoefTable[,3]
llk[   1] <- summary(nl_1_2345)$logLik
nl.st[ 1] <- "1_2345"

#02
nl_2_1345 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0,
         nests = list( n2 = c('2tokyo'),
                       n1345  = c('1iba','3hachi','4rail','5seikan')), un.nest.el=T)
summary(nl_2_1345)
para[, 2] <- summary(nl_2_1345)$CoefTable[,1]
tval[, 2] <- summary(nl_2_1345)$CoefTable[,3]
llk[   2] <- summary(nl_2_1345)$logLik
nl.st[ 2] <- "2_1345"

#03
nl_3_1245 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n3 = c('3hachi'),
                       n1245  = c('1iba','2tokyo','4rail','5seikan')), un.nest.el=T)
summary(nl_3_1245)
para[, 3] <- summary(nl_3_1245)$CoefTable[,1]
tval[, 3] <- summary(nl_3_1245)$CoefTable[,3]
llk[   3] <- summary(nl_3_1245)$logLik
nl.st[ 3] <- "3_1245"

#04
nl_4_1235 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n4 = c('4rail'),
                       n1245  = c('1iba','2tokyo','3hachi','5seikan')), un.nest.el=T)
summary(nl_4_1235)
para[, 4] <- summary(nl_4_1235)$CoefTable[,1]
tval[, 4] <- summary(nl_4_1235)$CoefTable[,3]
llk[   4] <- summary(nl_4_1235)$logLik
nl.st[ 4] <- "4_1235"

#05
nl_5_1234 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n5 = c('5seikan'),
                       n1234  = c('1iba','2tokyo','3hachi','4rail')), un.nest.el=T)
summary(nl_5_1234)
para[, 5] <- summary(nl_5_1234)$CoefTable[,1]
tval[, 5] <- summary(nl_5_1234)$CoefTable[,3]
llk[   5] <- summary(nl_5_1234)$logLik
nl.st[ 5] <- "5_1234"

#06
nl_12_345 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n12 = c('1iba','2tokyo'),
                       n345  = c('3hachi','4rail','5seikan')), un.nest.el=T)
summary(nl_12_345)
para[, 6] <- summary(nl_12_345)$CoefTable[,1]
tval[, 6] <- summary(nl_12_345)$CoefTable[,3]
llk[   6] <- summary(nl_12_345)$logLik
nl.st[ 6] <- "12_345"

#07
nl_13_245 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n13 = c('1iba','3hachi'),
                       n245  = c('2tokyo','4rail','5seikan')), un.nest.el=T)
summary(nl_13_245)
para[, 7] <- summary(nl_13_245)$CoefTable[,1]
tval[, 7] <- summary(nl_13_245)$CoefTable[,3]
llk[   7] <- summary(nl_13_245)$logLik
nl.st[ 7] <- "13_245"

#08
nl_14_235 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n14 = c('1iba','4rail'),
                       n235  = c('2tokyo','3hachi','5seikan')), un.nest.el=T)
summary(nl_14_235)
para[, 8] <- summary(nl_14_235)$CoefTable[,1]
tval[, 8] <- summary(nl_14_235)$CoefTable[,3]
llk[   8] <- summary(nl_14_235)$logLik
nl.st[ 8] <- "14_235"

#09
nl_15_234 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n15 = c('1iba','5seikan'),
                       n234  = c('2tokyo','3hachi','4rail')), un.nest.el=T)
summary(nl_15_234)
para[, 9] <- summary(nl_15_234)$CoefTable[,1]
tval[, 9] <- summary(nl_15_234)$CoefTable[,3]
llk[   9] <- summary(nl_15_234)$logLik
nl.st[ 9] <- "15_234"

#10
nl_23_145 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n23 = c('2tokyo','3hachi'),
                       n145  = c('1iba','4rail','5seikan')), un.nest.el=T)
summary(nl_23_145)
para[,10] <- summary(nl_23_145)$CoefTable[,1]
tval[,10] <- summary(nl_23_145)$CoefTable[,3]
llk[  10] <- summary(nl_23_145)$logLik
nl.st[10] <- "23_145"

#11
nl_24_135 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n24 = c('2tokyo','4rail'),
                       n135  = c('1iba','3hachi','5seikan')), un.nest.el=T)
summary(nl_24_135)
para[,11] <- summary(nl_24_135)$CoefTable[,1]
tval[,11] <- summary(nl_24_135)$CoefTable[,3]
llk[  11] <- summary(nl_24_135)$logLik
nl.st[11] <- "24_135"

#12
nl_25_134 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n25 = c('2tokyo','5seikan'),
                       n134  = c('1iba','3hachi','4rail')), un.nest.el=T)
summary(nl_25_134)
para[,12] <- summary(nl_25_134)$CoefTable[,1]
tval[,12] <- summary(nl_25_134)$CoefTable[,3]
llk[  12] <- summary(nl_25_134)$logLik
nl.st[12] <- "25_134"

#13
nl_34_125 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n34 = c('3hachi','4rail'),
                       n125  = c('1iba','2tokyo','5seikan')), un.nest.el=T)
summary(nl_34_125)
para[,13] <- summary(nl_34_125)$CoefTable[,1]
tval[,13] <- summary(nl_34_125)$CoefTable[,3]
llk[  13] <- summary(nl_34_125)$logLik
nl.st[13] <- "34_125"

#14
nl_35_124 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n35 = c('3hachi','5seikan'),
                       n124  = c('1iba','2tokyo','4rail')), un.nest.el=T)
summary(nl_35_124)
para[,14] <- summary(nl_35_124)$CoefTable[,1]
tval[,14] <- summary(nl_35_124)$CoefTable[,3]
llk[  14] <- summary(nl_35_124)$logLik
nl.st[14] <- "35_124"

#15
nl_45_123 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n45 = c('4rail','5seikan'),
                       n123  = c('1iba','2tokyo','3hachi')), un.nest.el=T)
summary(nl_45_123)
para[,15] <- summary(nl_45_123)$CoefTable[,1]
tval[,15] <- summary(nl_45_123)$CoefTable[,3]
llk[  15] <- summary(nl_45_123)$logLik
nl.st[15] <- "45_123"

#16
nl_1_23_45 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n1 = c('1iba'),n23 = c('2tokyo','3hachi'),
                       n45 = c('4rail','5seikan')), un.nest.el=T)
summary(nl_1_23_45)
para[,16] <- summary(nl_1_23_45)$CoefTable[,1]
tval[,16] <- summary(nl_1_23_45)$CoefTable[,3]
llk[  16] <- summary(nl_1_23_45)$logLik
nl.st[16] <- "1_23_45"

#17
nl_1_24_35 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n1 = c('1iba'),n24 = c('2tokyo','4rail'),
                       n35 = c('3hachi','5seikan')), un.nest.el=T)
summary(nl_1_24_35)
para[,17] <- summary(nl_1_24_35)$CoefTable[,1]
tval[,17] <- summary(nl_1_24_35)$CoefTable[,3]
llk[  17] <- summary(nl_1_24_35)$logLik
nl.st[17] <- "1_24_35"

#18
nl_1_25_34 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n1 = c('1iba'),n25 = c('2tokyo','5seikan'),
                       n34 = c('3hachi','4rail')), un.nest.el=T)
summary(nl_1_25_34)
para[,18] <- summary(nl_1_25_34)$CoefTable[,1]
tval[,18] <- summary(nl_1_25_34)$CoefTable[,3]
llk[  18] <- summary(nl_1_25_34)$logLik
nl.st[18] <- "1_25_34"

#19
nl_2_13_45 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0,
         nests = list( n2 = c('2tokyo'),n13 = c('1iba','3hachi'),
                       n45 = c('4rail','5seikan')), un.nest.el=T)
summary(nl_2_13_45)
para[,19] <- summary(nl_2_13_45)$CoefTable[,1]
tval[,19] <- summary(nl_2_13_45)$CoefTable[,3]
llk[  19] <- summary(nl_2_13_45)$logLik
nl.st[19] <- "2_13_45"

#20
nl_2_14_35 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n2 = c('2tokyo'),n14 = c('1iba','4rail'),
                       n35 = c('3hachi','5seikan')), un.nest.el=T)
summary(nl_2_14_35)
para[,20] <- summary(nl_2_14_35)$CoefTable[,1]
tval[,20] <- summary(nl_2_14_35)$CoefTable[,3]
llk[  20] <- summary(nl_2_14_35)$logLik
nl.st[20] <- "2_14_35"

#21
nl_2_15_34 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n2 = c('2tokyo'),n15 = c('1iba','5seikan'),
                       n34 = c('3hachi','4rail')), un.nest.el=T)
summary(nl_2_15_34)
para[,21] <- summary(nl_2_15_34)$CoefTable[,1]
tval[,21] <- summary(nl_2_15_34)$CoefTable[,3]
llk[  21] <- summary(nl_2_15_34)$logLik
nl.st[21] <- "2_15_34"

#22
nl_3_12_45 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n3 = c('3hachi'),n12 = c('1iba','2tokyo'),
                       n45 = c('4rail','5seikan')), un.nest.el=T)
summary(nl_3_12_45)
para[,22] <- summary(nl_3_12_45)$CoefTable[,1]
tval[,22] <- summary(nl_3_12_45)$CoefTable[,3]
llk[  22] <- summary(nl_3_12_45)$logLik
nl.st[22] <- "3_12_45"

#23
nl_3_14_25 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n3 = c('3hachi'),n14 = c('1iba','4rail'),
                       n25 = c('2tokyo','5seikan')), un.nest.el=T)
summary(nl_3_14_25)
para[,23] <- summary(nl_3_14_25)$CoefTable[,1]
tval[,23] <- summary(nl_3_14_25)$CoefTable[,3]
llk[  23] <- summary(nl_3_14_25)$logLik
nl.st[23] <- "3_14_25"

#24
nl_3_15_24 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n3 = c('3hachi'),n15 = c('1iba','5seikan'),
                       n24 = c('2tokyo','4rail')), un.nest.el=T)
summary(nl_3_15_24)
para[,24] <- summary(nl_3_15_24)$CoefTable[,1]
tval[,24] <- summary(nl_3_15_24)$CoefTable[,3]
llk[  24] <- summary(nl_3_15_24)$logLik
nl.st[24] <- "3_15_24"

#25
nl_4_12_35 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n4 = c('4rail'),n12 = c('1iba','2tokyo'),
                       n35 = c('3hachi','5seikan')), un.nest.el=T)
summary(nl_4_12_35)
para[,25] <- summary(nl_4_12_35)$CoefTable[,1]
tval[,25] <- summary(nl_4_12_35)$CoefTable[,3]
llk[  25] <- summary(nl_4_12_35)$logLik
nl.st[25] <- "4_12_35"

#26
nl_4_13_25 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n4 = c('4rail'),n13 = c('1iba','3hachi'),
                       n25 = c('2tokyo','5seikan')), un.nest.el=T)
summary(nl_4_13_25)
para[,26] <- summary(nl_4_13_25)$CoefTable[,1]
tval[,26] <- summary(nl_4_13_25)$CoefTable[,3]
llk[  26] <- summary(nl_4_13_25)$logLik
nl.st[26] <- "4_13_25"

#27
nl_4_15_23 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n4 = c('4rail'),n15 = c('1iba','5seikan'),
                       n23 = c('2tokyo','3hachi')), un.nest.el=T)
summary(nl_4_15_23)
para[,27] <- summary(nl_4_15_23)$CoefTable[,1]
tval[,27] <- summary(nl_4_15_23)$CoefTable[,3]
llk[  27] <- summary(nl_4_15_23)$logLik
nl.st[27] <- "4_15_23"

#28
nl_5_12_34 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n5 = c('5seikan'),n12 = c('1iba','2tokyo'),
                       n34 = c('3hachi','4rail')), un.nest.el=T)
summary(nl_5_12_34)
para[,28] <- summary(nl_5_12_34)$CoefTable[,1]
tval[,28] <- summary(nl_5_12_34)$CoefTable[,3]
llk[  28] <- summary(nl_5_12_34)$logLik
nl.st[28] <- "5_12_34"

#29
nl_5_13_24 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n5 = c('5seikan'),n13 = c('1iba','3hachi'),
                       n24 = c('2tokyo','4rail')), un.nest.el=T)
summary(nl_5_13_24)
para[,29] <- summary(nl_5_13_24)$CoefTable[,1]
tval[,29] <- summary(nl_5_13_24)$CoefTable[,3]
llk[  29] <- summary(nl_5_13_24)$logLik
nl.st[29] <- "5_13_24"

#30
nl_5_14_23 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n5 = c('5seikan'),n14 = c('1iba','4rail'),
                       n23 = c('2tokyo','3hachi')), un.nest.el=T)
summary(nl_5_14_23)
para[,30] <- summary(nl_5_14_23)$CoefTable[,1]
tval[,30] <- summary(nl_5_14_23)$CoefTable[,3]
llk[  30] <- summary(nl_5_14_23)$logLik
nl.st[30] <- "5_14_23"

#31
nl_45_1_2_3 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n45 = c('4rail','5seikan'),n1 = c('1iba'),
                        n2 = c('2tokyo'), n3 = c('3hachi')), un.nest.el=T)
summary(nl_45_1_2_3)
para[,31] <- summary(nl_45_1_2_3)$CoefTable[,1]
tval[,31] <- summary(nl_45_1_2_3)$CoefTable[,3]
llk[  31] <- summary(nl_45_1_2_3)$logLik
nl.st[31] <- "45_1_2_3"

#32
nl_35_1_2_4 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n35 = c('3hachi','5seikan'),n1 = c('1iba'),
                        n2 = c('2tokyo'), n4 = c('4rail')), un.nest.el=T)
summary(nl_35_1_2_4)
para[,32] <- summary(nl_35_1_2_4)$CoefTable[,1]
tval[,32] <- summary(nl_35_1_2_4)$CoefTable[,3]
llk[  32] <- summary(nl_35_1_2_4)$logLik
nl.st[32] <- "35_1_2_4"

#33
nl_25_1_3_4 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n25 = c('2tokyo','5seikan'),n1 = c('1iba'),
                        n3 = c('3hachi'), n4 = c('4rail')), un.nest.el=T)
summary(nl_25_1_3_4)
para[,33] <- summary(nl_25_1_3_4)$CoefTable[,1]
tval[,33] <- summary(nl_25_1_3_4)$CoefTable[,3]
llk[  33] <- summary(nl_25_1_3_4)$logLik
nl.st[33] <- "25_1_3_4"

#34
nl_15_2_3_4 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n15 = c('1iba','5seikan'),n2 = c('2tokyo'),
                       n3 = c('3hachi'), n4 = c('4rail')), un.nest.el=T)
summary(nl_15_2_3_4)
para[,34] <- summary(nl_15_2_3_4)$CoefTable[,1]
tval[,34] <- summary(nl_15_2_3_4)$CoefTable[,3]
llk[  34] <- summary(nl_15_2_3_4)$logLik
nl.st[34] <- "15_2_3_4"

#35
nl_34_1_2_5 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n34 = c('3hachi','4rail'),n1 = c('1iba'),
                        n2 = c('2tokyo'), n5 = c('5seikan')), un.nest.el=T)
summary(nl_34_1_2_5)
para[,35] <- summary(nl_34_1_2_5)$CoefTable[,1]
tval[,35] <- summary(nl_34_1_2_5)$CoefTable[,3]
llk[  35] <- summary(nl_34_1_2_5)$logLik
nl.st[35] <- "34_1_2_5"

#36
nl_24_1_3_5 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n24 = c('2tokyo','4rail'),n1 = c('1iba'),
                        n3 = c('3hachi'), n5 = c('5seikan')), un.nest.el=T)
summary(nl_24_1_3_5)
para[,36] <- summary(nl_24_1_3_5)$CoefTable[,1]
tval[,36] <- summary(nl_24_1_3_5)$CoefTable[,3]
llk[  36] <- summary(nl_24_1_3_5)$logLik
nl.st[36] <- "24_1_3_5"

#37
nl_14_2_3_5 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n14 = c('1iba','4rail'),n2 = c('2tokyo'),
                       n3 = c('3hachi'), n5 = c('5seikan')), un.nest.el=T)
summary(nl_14_2_3_5)
para[,37] <- summary(nl_14_2_3_5)$CoefTable[,1]
tval[,37] <- summary(nl_14_2_3_5)$CoefTable[,3]
llk[  37] <- summary(nl_14_2_3_5)$logLik
nl.st[37] <- "14_2_3_5"

#38
nl_23_1_4_5 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n23 = c('2tokyo','3hachi'),n1 = c('1iba'),
                        n4 = c('4rail'), n5 = c('5seikan')), un.nest.el=T)
summary(nl_23_1_4_5)
para[,38] <- summary(nl_23_1_4_5)$CoefTable[,1]
tval[,38] <- summary(nl_23_1_4_5)$CoefTable[,3]
llk[  38] <- summary(nl_23_1_4_5)$logLik
nl.st[38] <- "23_1_4_5"

#39
nl_13_2_4_5 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n13 = c('1iba','3hachi'),n2 = c('2tokyo'),
                       n4 = c('4rail'), n5 = c('5seikan')), un.nest.el=T)
summary(nl_13_2_4_5)
para[,39] <- summary(nl_13_2_4_5)$CoefTable[,1]
tval[,39] <- summary(nl_13_2_4_5)$CoefTable[,3]
llk[  39] <- summary(nl_13_2_4_5)$logLik
nl.st[39] <- "13_2_4_5"

#40
nl_12_3_4_5 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n12 = c('1iba','2tokyo'),n3 = c('3hachi'),
                       n4 = c('4rail'), n5 = c('5seikan')), un.nest.el=T)
summary(nl_12_3_4_5)
para[,40] <- summary(nl_12_3_4_5)$CoefTable[,1]
tval[,40] <- summary(nl_12_3_4_5)$CoefTable[,3]
llk[  40] <- summary(nl_12_3_4_5)$logLik
nl.st[40] <- "12_3_4_5"

#41
nl_1_2_345 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n1 = c('1iba'),n2 = c('2tokyo'),
                       n345  = c('3hachi','4rail','5seikan')), un.nest.el=T)
summary(nl_1_2_345)
para[,41] <- summary(nl_1_2_345)$CoefTable[,1]
tval[,41] <- summary(nl_1_2_345)$CoefTable[,3]
llk[  41] <- summary(nl_1_2_345)$logLik
nl.st[41] <- "1_2_345"

#42
nl_1_3_245 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n1 = c('1iba'),n3 = c('3hachi'),
                       n245  = c('2tokyo','4rail','5seikan')), un.nest.el=T)
summary(nl_1_3_245)
para[,42] <- summary(nl_1_3_245)$CoefTable[,1]
tval[,42] <- summary(nl_1_3_245)$CoefTable[,3]
llk[  42] <- summary(nl_1_3_245)$logLik
nl.st[42] <- "1_3_245"

#43
nl_1_4_235 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n1 = c('1iba'),n4 = c('4rail'),
                       n235  = c('2tokyo','3hachi','5seikan')), un.nest.el=T)
summary(nl_1_4_235)
para[,43] <- summary(nl_1_4_235)$CoefTable[,1]
tval[,43] <- summary(nl_1_4_235)$CoefTable[,3]
llk[  43] <- summary(nl_1_4_235)$logLik
nl.st[43] <- "1_4_235"

#44
nl_1_5_234 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n1 = c('1iba'),n5 = c('5seikan'),
                       n234 = c('2tokyo','3hachi','4rail')), un.nest.el=T)
summary(nl_1_5_234)
para[,44] <- summary(nl_1_5_234)$CoefTable[,1]
tval[,44] <- summary(nl_1_5_234)$CoefTable[,3]
llk[  44] <- summary(nl_1_5_234)$logLik
nl.st[44] <- "1_5_234"

#45
nl_2_3_145 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n2 = c('2tokyo'),n3 = c('3hachi'),
                       n145  = c('1iba','4rail','5seikan')), un.nest.el=T)
summary(nl_2_3_145)
para[,45] <- summary(nl_2_3_145)$CoefTable[,1]
tval[,45] <- summary(nl_2_3_145)$CoefTable[,3]
llk[  45] <- summary(nl_2_3_145)$logLik
nl.st[45] <- "2_3_145"

#46
nl_2_4_135 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n2 = c('2tokyo'),n4 = c('4rail'),
                       n135  = c('1iba','3hachi','5seikan')), un.nest.el=T)
summary(nl_2_4_135)
para[,46] <- summary(nl_2_4_135)$CoefTable[,1]
tval[,46] <- summary(nl_2_4_135)$CoefTable[,3]
llk[  46] <- summary(nl_2_4_135)$logLik
nl.st[46] <- "2_4_135"

#47
nl_2_5_134 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n2 = c('2tokyo'),n5 = c('5seikan'),
                       n134 = c('1iba','3hachi','4rail')), un.nest.el=T)
summary(nl_2_5_134)
para[,47] <- summary(nl_2_5_134)$CoefTable[,1]
tval[,47] <- summary(nl_2_5_134)$CoefTable[,3]
llk[  47] <- summary(nl_2_5_134)$logLik
nl.st[47] <- "2_5_134"

#48
nl_3_4_125 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n3 = c('3hachi'),n4 = c('4rail'),
                       n125  = c('1iba','2tokyo','5seikan')), un.nest.el=T)
summary(nl_3_4_125)
para[,48] <- summary(nl_3_4_125)$CoefTable[,1]
tval[,48] <- summary(nl_3_4_125)$CoefTable[,3]
llk[  48] <- summary(nl_3_4_125)$logLik
nl.st[48] <- "3_4_125"

#49
nl_3_5_124 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n3 = c('3hachi'),n5 = c('5seikan'),
                       n124 = c('1iba','2tokyo','4rail')), un.nest.el=T)
summary(nl_3_5_124)
para[,49] <- summary(nl_3_5_124)$CoefTable[,1]
tval[,49] <- summary(nl_3_5_124)$CoefTable[,3]
llk[  49] <- summary(nl_3_5_124)$logLik
nl.st[49] <- "3_5_124"

#50
nl_4_5_123 <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt, start=b0, 
         nests = list( n4 = c('4rail'),n5 = c('5seikan'),
                       n123 = c('1iba','2tokyo','3hachi')), un.nest.el=T)
summary(nl_4_5_123)
para[,50] <- summary(nl_4_5_123)$CoefTable[,1]
tval[,50] <- summary(nl_4_5_123)$CoefTable[,3]
llk[  50] <- summary(nl_4_5_123)$logLik
nl.st[50] <- "4_5_123"

#############################

write.csv(para ,"mlogit50-para.csv",row.names=F)
write.csv(tval ,"mlogit50-tval.csv",row.names=F)
write.csv(llk  ,"mlogit50-llk.csv",row.names=F)
write.csv(nl.st,"mlogit50name.csv",row.names=F)


####### MNP #############################################
system.time( mnp <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt,
                           probit=TRUE, print.level=1) )
summary(mnp)

####### MXL #############################################
mxl <- mlogit(mode~time+cost+wei1+wei2+wei3+wei4, m_dt,
       rpar=c(time='n'), R = 1000, print.level=1)
summary(mxl)

####### MNP by "MNP" ####################################
library(MNP)

dt <-read.csv("d1000.csv",header=T)

md <- matrix("",nrow=nrow(dt),ncol=1); mm <- c("iba","tokyo","hachi","rail","seikan")
md <- mm[dt[,1]]; dt[,1] <- md
colnames(dt)[ 2] <- "time.iba"
colnames(dt)[ 3] <- "time.tokyo"
colnames(dt)[ 4] <- "time.hachi"
colnames(dt)[ 5] <- "time.rail"
colnames(dt)[ 6] <- "time.seikan"

colnames(dt)[ 7] <- "cost.iba"
colnames(dt)[ 8] <- "cost.tokyo"
colnames(dt)[ 9] <- "cost.hachi"
colnames(dt)[10] <- "cost.rail"
colnames(dt)[11] <- "cost.seikan"

colnames(dt)[12] <- "weight"

res.mnp <- mnp(mode ~ 1 + weight,
     choiceX=list( iba   =cbind(time.iba,    cost.iba),
                   tokyo =cbind(time.tokyo,  cost.tokyo),
                   hachi =cbind(time.hachi,  cost.hachi),
                   rail  =cbind(time.rail,   cost.rail),
                   seikan=cbind(time.seikan, cost.seikan) ),
     cXnames=c("time","cost"),
     data=dt, n.draws=10000, burnin=500, thin=3, verbose=T)
summary(res.mnp)
